-- Actel Corporation Proprietary and Confidential
--  Copyright 2008 Actel Corporation.  All rights reserved.
-- ANY USE OR REDISTRIBUTION IN PART OR IN WHOLE MUST BE HANDLED IN
-- ACCORDANCE WITH THE ACTEL LICENSE AGREEMENT AND MUST BE APPROVED
-- IN ADVANCE IN WRITING.
--  Revision Information:
-- Jun09    Revision 4.1
-- Aug10    Revision 4.2
-- SVN Revision Information:
-- SVN $Revision: 8508 $
-- SVN $Date: 2009-06-15 16:49:49 -0700 (Mon, 15 Jun 2009) $
library ieee;
use ieee.Std_logic_1164.all;
use IEEE.STD_logic_arith.all;
use ieeE.std_LOGIC_UNSIGned.all;
entity myUART_myUART_0_RX_ASYNC is
generic (RX_Fifo: INTEGER := 0); port (clk: in std_lOGIC;
CUARTo: in std_logic;
reseT_N: in STD_LOGIC;
BIT8: in STD_logic;
parity_en: in stD_LOGIC;
ODD_N_EVEN: in std_logic;
CUARTool: in std_logIC;
CUARTlol: in std_logic;
CUARTIOL: in STD_logic;
RX: in stD_LOGIC;
OVERFLOW: out STD_logic;
parity_err: out sTD_LOGIC;
CUARTOLL: out STD_logic;
CUARTLLL: out STd_logic;
CUARTill: out std_logiC;
CUARTLIl: out STD_LOGIC;
CUARTOIL: out STD_logic;
CUARTiil: out std_logiC;
CUARTo0l: out STD_LOGic_vector(7 downto 0);
CUARTL0L: out Std_logic);
end entity myUART_myUART_0_Rx_asyNC;

architecture CUARTi1 of myUART_myUART_0_RX_ASync is

type CUARToiii is (CUARTI00,CUARTLIII,CUARTIIII);

signal CUARToool: CUARToiiI;

signal CUARTo0ii: stD_LOGIC_VECTor(3 downto 0);

signal CUARTl0ii: std_logic;

signal CUARTI0II: std_logic_veCTOR(8 downto 0);

signal CUARTO1II: Std_logic;

signal CUARTl1ii: std_logic_VECTOR(3 downto 0);

signal CUARTi1II: STD_LOGIc;

signal CUARTOO0I: STD_logic_vector(2 downto 0);

signal CUARTLo0i: std_logic;

signal CUARTIO0I: Std_logic_vector(1 downto 0);

signal CUARTol0i: STD_LOGIC_VECtor(1 downto 0);

signal CUARTLL0I: std_logic_vectOR(3 downto 0);

signal CUARTOO1: STD_Logic_vector(3 downto 0);

signal CUARTil0i: STD_LOGic_vector(3 downto 0);

signal CUARTOI0I: std_logic_veCTOR(3 downto 0);

signal CUARTli0i: std_lOGIC;

signal CUARTii0I: STD_LOGIC;

signal CUARTo00i: std_logIC;

signal CUARTl00i: std_logic;

signal CUARTi00i: std_logic;

signal CUARTO10I: STD_LOgic;

signal CUARTl10i: std_logic;

signal CUARTi10i: std_logic;

signal CUARToo1i: std_logiC_VECTOR(7 downto 0);

signal CUARTLO1i: std_logic;

begin
CUARTill <= CUARTI00I;
CUARTOLL <= CUARTO00I;
oveRFLOW <= CUARTLI0I;
parity_eRR <= CUARTII0I;
CUARTOIL <= CUARTO10i;
CUARTIIl <= CUARTi10i;
CUARTO0L <= CUARTOO1I;
CUARTL0L <= CUARTlO1I;
CUARTlll <= '1' when (CUARTOool = CUARTI00) else
'0';
CUARTLIL <= CUARTl10i;
CUARTIO1I:
process (clk,reset_N)
begin
if (reset_n = '0') then
CUARTOO0I <= "000";
elsif (clk'event and CLK = '1') then
if (CUARTo = '1') then
CUARToo0i(1 downto 0) <= CUARToo0i(2 downto 1);
CUARTOo0i(2) <= RX;
end if;
end if;
end process CUARTio1i;
process (CUARTOO0i)
begin
case CUARToo0i is
when "000" =>
CUARTl0ii <= '0';
when "001" =>
CUARTl0ii <= '0';
when "010" =>
CUARTl0iI <= '0';
when "011" =>
CUARTL0II <= '1';
when "100" =>
CUARTL0II <= '0';
when "101" =>
CUARTl0ii <= '1';
when "110" =>
CUARTl0ii <= '1';
when others =>
CUARTl0ii <= '1';
end case;
end process;
CUARTOL1I:
process (clk,reset_n)
begin
if (reset_n = '0') then
CUARTO0ii <= "0000";
elsif (clk'event and CLK = '1') then
if (CUARTo = '1') then
if (CUARTOOOL = CUARTi00 and (CUARTl0ii = '1' or CUARTo0iI = "1000")) then
CUARTo0ii <= "0000";
else
CUARTO0II <= CUARTo0ii+"0001";
end if;
end if;
end if;
end process CUARTol1i;
CUARTLL1I:
process (clk,reset_n)
begin
if (RESET_N = '0') then
CUARTli0i <= '0';
elsif (clK'event and CLK = '1') then
if (CUARTo = '1') then
if (CUARTlo0i = '1') then
CUARTli0i <= '1';
end if;
end if;
if (CUARTool = '1') then
CUARTLi0i <= '0';
end if;
end if;
end process CUARTLL1i;
CUARTIL1I:
process (clK,resET_N)
begin
if (reset_n = '0') then
CUARTo00i <= '0';
elsif (CLK'EVENT and clk = '1') then
if (CUARTiol = '1') then
CUARTo00i <= '0';
elsif (CUARTO = '1') then
if (CUARTl00i = '1') then
CUARTo00i <= '1';
end if;
else
CUARTO00I <= CUARTO00I;
end if;
end if;
end process CUARTIL1I;
CUARToo1 <= "1000" when (bit8 = '1' and paritY_EN = '0') else
"1001";
CUARTIL0I <= "1000" when (bit8 = '0' and parity_EN = '1') else
CUARTOO1;
CUARTOI0i <= "0111" when (bit8 = '0' and pARITY_EN = '0') else
CUARTil0i;
CUARTll0i <= CUARTOi0i;
CUARTOI1I:
process (clk,reset_n)
begin
if (RESEt_n = '0') then
CUARToool <= CUARTI00;
CUARToo1i <= "00000000";
CUARTLO0I <= '0';
CUARTl00i <= '0';
CUARTi00i <= '0';
elsif (clk'event and clk = '1') then
if (CUARTo = '1') then
CUARTLO0I <= '0';
CUARTL00i <= '0';
CUARTI00I <= '0';
case CUARTOool is
when CUARTI00 =>
if (CUARTO0II = "1000") then
CUARToOOL <= CUARTLIII;
else
CUARTOOOl <= CUARTI00;
end if;
when CUARTliii =>
if (CUARTl1ii = CUARTll0i) then
CUARToool <= CUARTIIII;
CUARTlo0i <= CUARTi1II;
if (CUARTI1Ii = '0') then
CUARTOO1I <= (bit8 and CUARTi0ii(7))&CUARTi0ii(6 downto 0);
end if;
else
CUARTOool <= CUARTliii;
end if;
when CUARTIIII =>
if (CUARTO0II = "1110") then
if (CUARTl0iI = '0') then
CUARTl00i <= '1';
end if;
elsif (CUARTO0ii = "1111") then
CUARTI00I <= '1';
CUARTOOOL <= CUARTI00;
else
CUARTOOOL <= CUARTIIII;
end if;
when others =>
CUARToooL <= CUARTI00;
end case;
end if;
end if;
end process CUARToi1i;
CUARTIo0i <= BIT8&PARITY_EN;
CUARTLI1I:
process (clk,reset_n)
begin
if (reSET_N = '0') then
CUARTI0II(8 downto 0) <= "000000000";
CUARTl1ii <= "0000";
elsif (clk'event and CLK = '1') then
if (CUARTO = '1') then
if (CUARToool = CUARTI00) then
CUARTi0ii(8 downto 0) <= "000000000";
CUARTL1II <= "0000";
else
if (CUARTo0ii = "1111") then
CUARTl1ii <= CUARTl1ii+"0001";
case CUARTio0i is
when "00" =>
CUARTi0ii(5 downto 0) <= CUARTI0II(6 downto 1);
CUARTi0ii(6) <= CUARTl0ii;
when "11" =>
CUARTi0ii(7 downto 0) <= CUARTI0II(8 downto 1);
CUARTI0Ii(8) <= CUARTl0ii;
when others =>
CUARTi0ii(6 downto 0) <= CUARTI0II(7 downto 1);
CUARTI0ii(7) <= CUARTl0iI;
end case;
end if;
end if;
end if;
end if;
end process CUARTli1i;
CUARTII1I:
process (clk,reset_n)
begin
if (RESET_n = '0') then
CUARTo1ii <= '0';
elsif (clK'event and CLK = '1') then
if (CUARTO = '1') then
if (CUARTo0iI = "1111" and PARITY_En = '1') then
CUARTo1ii <= CUARTo1ii xor CUARTl0ii;
end if;
if (CUARToool = CUARTiiii) then
CUARTo1ii <= '0';
end if;
end if;
end if;
end process CUARTII1i;
CUARTOL0I <= bit8&Odd_n_even;
CUARTo01i:
process (CLk,RESet_n)
begin
if (rESET_N = '0') then
CUARTII0i <= '0';
elsif (clk'event and CLK = '1') then
if ((CUARTO = '1' and parity_EN = '1') and CUARTo0iI = "1111") then
case CUARTOL0I is
when "00" =>
if (CUARTl1ii = "0111") then
CUARTii0i <= CUARTO1II xor CUARTl0ii;
end if;
when "01" =>
if (CUARTl1ii = "0111") then
CUARTii0i <= not (CUARTo1iI xor CUARTL0II);
end if;
when "10" =>
if (CUARTl1ii = "1000") then
CUARTii0i <= CUARTO1II xor CUARTl0ii;
end if;
when "11" =>
if (CUARTl1ii = "1000") then
CUARTii0i <= not (CUARTo1ii xor CUARTl0ii);
end if;
when others =>
CUARTii0i <= '0';
end case;
end if;
if (CUARTLOL = '1') then
CUARTII0i <= '0';
end if;
end if;
end process CUARTo01i;
CUARTl01I:
process (clk,reset_n)
begin
if (REset_n = '0') then
CUARTi1ii <= '0';
CUARTlo1i <= '1';
CUARTO10I <= '0';
CUARTl10I <= '0';
elsif (clk'EVENT and clk = '1') then
CUARTlo1i <= '1';
CUARTo10i <= '0';
CUARTL10I <= '0';
if (CUARTO = '1') then
if (BIt8 = '1') then
if (parity_en = '1') then
if (CUARTL1II = "1001" and CUARToool = CUARTliii) then
CUARTLO1I <= '0';
CUARTo10i <= '1';
CUARTL10I <= '1';
if (rx_fifo = 2#0#) then
CUARTi1ii <= '1';
end if;
end if;
else
if (CUARTl1ii = "1000" and CUARToool = CUARTliii) then
CUARTLO1I <= '0';
CUARTO10i <= '1';
CUARTl10i <= '1';
if (RX_fifo = 2#0#) then
CUARTI1II <= '1';
end if;
end if;
end if;
else
if (PARITY_EN = '1') then
if (CUARTl1ii = "1000" and CUARTOOOL = CUARTLIII) then
CUARTlo1i <= '0';
CUARTo10I <= '1';
CUARTL10i <= '1';
if (RX_FIFO = 2#0#) then
CUARTi1ii <= '1';
end if;
end if;
else
if (CUARTl1ii = "0111" and CUARToool = CUARTliii) then
CUARTLO1I <= '0';
CUARTo10i <= '1';
CUARTl10i <= '1';
if (Rx_fifo = 2#0#) then
CUARTI1II <= '1';
end if;
end if;
end if;
end if;
end if;
if (CUARTOOL = '1') then
CUARTI1ii <= '0';
end if;
end if;
end process CUARTl01i;
CUARTi10i <= CUARTi1ii;
end architecture CUARTI1;
