-- Global settings for comparator and system project.
package settings is
  constant OPAMP_TYPE   : integer  :=     0;      -- 1=LVPECL,-1=LVDS,0=simulation
  constant OPAMP_UPDATE : real     :=    15.0;    -- [ns]
  constant OPAMP_VFH    : real     :=    10.0;    -- [mV] falling edge start of switching
  constant OPAMP_VFL    : real     :=   -10.0;    -- [mV] falling edge end   of switching
  constant OPAMP_VRH    : real     :=    10.0;    -- [mV] rising  edge end   of switching
  constant OPAMP_VRL    : real     :=   -10.0;    -- [mV] rising  edge start of switching
  constant VCC          : real     :=     3.3;    -- [V] maximum of VCOMPARE
  constant VREF         : real     :=     1.25;   -- [V] reference voltage (center of dynamic input range)
  constant UPDATE_DIV   : positive :=     8;      -- [1..16] VCHARGE update rate = 4 MHz / UPDATE_DIV
  constant TAU          : real     :=   330.0;    -- [us] R * C
  constant SAMPLE_WIDTH : positive :=     8;      -- bits per SCALED sample
  constant RC_ACCURACY  : natural  :=     4;      -- additional accuracy bits of RC model
  constant AVG_SIZE     : natural  :=     4;      -- base for number of averages in RC filter
  constant MAX_GAIN     : positive :=    10;      -- [1..16] maximum configurable PGA gain
  constant BAUD_RATE    : natural  := 14400;      -- [baud] serial communication speed
  constant SAMPLE_DIV   : positive :=  1100;      -- sample rate = 4 MHz / UPDATE_DIV / SAMPLE_DIV
end package;
