`default_nettype none

// Minimum application utilizing the ADC
//  * generate sampling requests at fixed sampling rate
//  * translate user input into gain and calibration requests
//  * forward sampled value to UART transmitter
// 
// author: 
// date:   
module APPLICATION #(`include "settings.v")
 (input  wire                    CLK,            // clock                                             
  input  wire                    RSTN,           // synchronous reset (active low)                    
  input  wire              [4:0] SWITCH,         // asynchronous user input                           
  output wire              [3:0] GAIN,           // asynchronous PGA gain request                     
  input  wire [SAMPLE_WIDTH+3:0] UNSCALED,       // sampled value normalized by current PGA gain      
  output reg                     CALIBRATE,      // synchronous calibration request (active high)     
  output reg                     SAMPLE,         // synchronous sampling request (active high)        
  input  wire                    DONE,           // synchronous sampling confirmation (active high)   
  output wire              [7:0] D,              // byte to be transmitted via UART                   
  output wire                    WEN,            // synchronous UART write enable (active low)        
  input  wire                    RDY);           // synchronous UART ready confirmation (active high) 
/**********************************************************************************************************************/