`default_nettype none

// Toplevel module of comparator project.
//  * derive 4MHz and 4MHz/(SWITCH+1) clocks with corresponding synchronous resets from external clock and resets
//  * compare positive and negative input voltage (VP > VN?)
//  * register comparison with devided clock
//  
// author: 
// date:   
module TOP 
 (input  wire OSC_CLK,      // 48 MHz oscillator
  input  wire PO_RSTN,      // asynchronous power on reset (active low)
  input  wire PB_RSTN,      // asynchronous push button reset (active low)
  input  wire VP,           // positive differential voltage
  input  wire VN,           // negative differential voltage
  input  wire [3:0] SWITCH, // clock divider settings
  output wire [3:0] LED,    // clock divider indication
  output wire LOCK,         // asynchronous PLL lock (active low)
  output wire CLK,          // 4 MHz
  output wire RSTN,         // synchronous reset (active low)
  output wire DCLK,         // 4 MHz/(SWITCH+1)
  output wire DRSTN,        // synchronous reset (active low)
  output reg  COMPARE);     // registered comparator output
/**********************************************************************************************************************/